/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	属性変更 複製なしクラス
//		変更履歴
//			2004.07.21 新規作成 A.Shimoma
//							
//
package jp.co.ntt.lms.xmo.Lo;

import java.sql.SQLException;
import java.util.Hashtable;

import jp.co.ntt.lms.lo.LoPropertyDef;
import jp.co.ntt.lms.xmo.DataAccess;
import jp.co.ntt.lms.xmo.XMOException;
import jp.co.ntt.lms.xmo.util.DebugLog;


/**
 *
 * このクラスは属性変更対象LOの他参照(同リアルLOID)が
 * 無い場合に実行するクラスです。
 * 
 * @author A.Shimoma
 * 
 */
public class ChangeTypeNoCopyLo extends ChangeTypeAbstract {

	/**
	 * コンストラクタ
	 * 
	 */
	public ChangeTypeNoCopyLo() {
	}

	/**
	 * LOテーブルの更新を行います。
	 * 
	 * LOTypeをコンテナ｢0｣で更新を行います。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeLoAction()
	 */
	void changeLoAction() throws XMOException {

		putLoTableData( loID, realLoID, CONTAINER_TYPE, condition);
		
	}

	/**
	 * ログセッション情報の削除を行います。
	 * 
	 * リアルLOIDをキーに削除します。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeLoLogSessionAction()
	 */
	void changeLoLogSessionAction() throws XMOException {

		try {

			// ログセッション情報の削除
			objLogSession.delete(realLoID, objDataAccess);

		} catch (SQLException se) {
			DebugLog.write( this.getClass(), se, DebugLog.HIGHT );
			throw new XMOException( getMessageData( DB_ERR ) );
		}
		
	}

	/**
	 * 共通ログ情報変更アクションメソッド
	 * このクラスでは実装なし。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeLoLogAction()
	 */
	void changeLoLogAction() {
	}

	/**
	 * 評価情報の削除を行います。
	 * 
	 * リアルLOIDをキーに削除します。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeEvaluteAction()
	 */
	void changeEvaluteAction() throws XMOException {

		// 削除パラメータの設定
		Hashtable htbDelParam = new Hashtable();
		// 削除条件にLOIDを設定
		htbDelParam.put( DELETE_LOID, realLoID);
		
		// トランザクション共有のために現在使用中のコネクションインデックスを取得する
		Integer objConIndex = getConnectionIndex();
		htbDelParam.put( DataAccess.CONNECTIONINDEX, objConIndex );

		// 評価削除処理
		objEvalute.delete(htbDelParam);

	}

	/**
	 * 更新履歴テーブルへ登録を行います。
	 * 
	 * リアルLOIDをキーに現在日付でレコードを１件登録します。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeLoHistoryAction()
	 */
	void changeLoHistoryAction() throws XMOException {

		try{
			Hashtable htbInsParam = new Hashtable();
			htbInsParam.put(LOGIN_USER_ID, userID);
			htbInsParam.put(REAL_LOID, loID);
			objLoDataAccess.insertHistoryAction(htbInsParam, objDataAccess);
	
		} catch (SQLException se) {
			DebugLog.write( this.getClass(), se, DebugLog.HIGHT );
			throw new XMOException( getMessageData( DB_ERR ) );
		}

	}

	/**
	 * 個別ログの削除を行います。
	 * 
	 * リアルLOIDをキーに削除します。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeIndividualLogAction()
	 */
	void changeIndividualLogAction() throws XMOException {

		objLoTop.clear();
		if( !objLoTop.deleteIndividualLog( null, realLoID ) ) {
			throw new XMOException( objLoTop.getMessageData() );
		}
	}

	/**
	 * LO個別テーブルの削除を行います。
	 * 
	 * リアルLOIDをキーに削除します。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeOriginalLoAction()
	 */
	void changeOriginalLoAction() throws XMOException {

		objLoTop.clear();
		// 削除パラメータの設定
		Hashtable htbDelParam = new Hashtable();
		// 削除条件にLOIDを設定
		htbDelParam.put( LO_ID, realLoID );
		// 個別削除処理
		if( !objLoTop.setUp( LoPropertyDef.SETUP_DELETE, htbDelParam ) ) {
			throw new XMOException( objLoTop.getMessageData() );
		}
		
	}

}


